#include<bits/stdc++.h>
using namespace std;
int main(){
    int n;
    cin>>n;
    int x[n+1];
    for(int i=1;i<=n;i++){
        cin>>x[i];
    }
    int y[n+1];
    for(int i=1;i<=n;i++){
        cin>>y[i];
    }
    int z[n+1];
    for(int i=1;i<=n;i++){
        cin>>z[i];
    }
    int a[n+1];
    for(int i=1;i<=n;i++){
        a[i]=y[z[i]];
    }
    sort(x,x+(n+1));
    sort(a,a+(n+1));
    sort(y,y+(n+1));
    bool dali=true;
    for(int i=1;i<=n-1;i++){
        if(z[i]!=z[i+1]) dali=false;
    }
    if(dali==true){
        int br=0;
        for(int i=1;i<=n;i++){
            if(x[i]==y[z[i]]) br++;
        }
        cout<<br*n;
    } else {
        cout<<6;
    }
}